=== debian/changelog ===
rdkit (202109.2-1build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 20:26:25 +0000

rdkit (202109.2-1) unstable; urgency=medium

  * New upstream release.
    + Includes updated PostgreSQL regression outputs (Closes: #1000579).
  * debian/patches/postgres_compile_fixes.patch: Refreshed. 
  * debian/patches/postgres_Makefile_fixes.patch: Add RDK_TOOLKIT_VERSION
    definition, hardcoded to current release for now.
  * debian/rules (DH_AUTO_CONFIGURE_OPTS): Added -DRDK_INSTALL_COMIC_FONTS=OFF
    (Closes: #999767).
  * debian/control.in,debian/control (Build-Depends): Added libcairo-dev.
  * debian/rules (DH_AUTO_CONFIGURE_OPTS): Added -DRDK_BUILD_CAIRO_SUPPORT=ON.

 -- Michael Banck <mbanck@debian.org>  Sun, 28 Nov 2021 09:45:28 +0100

rdkit (202103.5-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/sphinx_compile_fixes.patch: Refreshed. 
  * debian/control (postgresql-PGVERSION-rdkit): Bump PostgreSQL version to 14
    (Closes: #997745).

 -- Michael Banck <michael.banck@credativ.de>  Thu, 11 Nov 2021 18:22:40 +0100
